/// <reference types="kendo-multi-calendar" />
/// <reference types="kendo-ui" />
declare namespace kendoExt {
    interface MultiDateSelectOptions {
        autoClose?: boolean;
        enable?: boolean;
        maxSelectedItems?: number;
        cleanSelectedItemsOnTodayClick?: boolean;
        placeholder?: string;
        tagTemplate?: string;
        values?: Date[];
        footer?: string;
        culture?: string;
        format?: string;
        min?: Date;
        max?: Date;
        start?: CalendarDepth;
        depth?: CalendarDepth;
        month?: Object;
        dates?: Date[];
    }
    class MultiDateSelect extends kendo.ui.Widget {
        static navigateEvent: string;
        static changeEvent: string;
        static openEvent: string;
        static closeEvent: string;
        private _multiSelect;
        private _multiCalendar;
        private _popup;
        constructor(element: Element | JQuery | string, options?: MultiDateSelectOptions);
        private static removeTime(date);
        private static isDateGreater(first, second);
        private static isDateLesser(first, second);
        open(): void;
        close(): void;
        toggle(): void;
        destroy(): void;
        enable(enable: boolean): void;
        readonly(readonly: boolean): void;
        max(max?: Date): Date;
        min(min?: Date): Date;
        value(values?: Date[]): Date[];
        values(values?: Date[]): Date[];
        multiSelect(): kendo.ui.MultiSelect;
        multiCalendar(): MultiCalendar;
        private initMultiSelect(parent);
        private initPopup(parent);
        private initCalendar(parent);
        private updateDateInterval();
        private updateMultiSelectValues(values);
        private updateMultiSelect();
    }
}
interface JQuery {
    kendoMultiDateSelect(options?: kendoExt.MultiDateSelectOptions): JQuery;
    data(key: 'kendoMultiDateSelect'): kendoExt.MultiDateSelect;
}
